import { Component, createElement } from 'react';
import { Motion, spring } from 'react-motion';
import Resizable from 'react-resizable-box';
import isEqual from 'lodash.isequal';

var _createClass$1 = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck$1(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn$1(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits$1(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Pane = function (_React$Component) {
  _inherits$1(Pane, _React$Component);

  function Pane() {
    _classCallCheck$1(this, Pane);

    return _possibleConstructorReturn$1(this, (Pane.__proto__ || Object.getPrototypeOf(Pane)).apply(this, arguments));
  }

  _createClass$1(Pane, [{
    key: 'render',
    value: function render() {
      return createElement(
        'div',
        { className: this.props.className },
        this.props.children
      );
    }
  }]);

  return Pane;
}(Component);

Pane.defaultProps = {
  minWidth: 0,
  minHeight: 0,
  maxWidth: undefined,
  maxHeight: undefined,
  style: {},
  className: '',
  isResizable: {
    x: true,
    y: true,
    xy: true
  },
  children: ''
};

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// $FlowIgnore
// $FlowIgnore

function reinsert(array, from, to) {
  var a = array.slice(0);
  var v = a[from];
  a.splice(from, 1);
  a.splice(to, 0, v);
  return a;
}

var directionDict = {
  right: 'x',
  bottom: 'y',
  bottomRight: 'xy'
};

var clamp = function clamp(n) {
  var min = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : n;
  var max = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : n;
  return Math.max(Math.min(n, max), min);
};

var springConfig = {
  damping: 30,
  stiffness: 500
};

var SortablePane = function (_React$Component) {
  _inherits(SortablePane, _React$Component);

  function SortablePane(props) {
    _classCallCheck(this, SortablePane);

    var _this = _possibleConstructorReturn(this, (SortablePane.__proto__ || Object.getPrototypeOf(SortablePane)).call(this, props));

    _this.getSurroundingHalfSizes = function (currentPane, sizes, margin) {
      var nextPane = currentPane + 1;
      var prevPane = currentPane - 1;

      return sizes.reduce(function (sums, val, index) {
        var newSums = {};
        if (index < prevPane) {
          newSums.previous = sums.previous + val + margin;
        } else if (index === prevPane) {
          newSums.previous = sums.previous + val / 2;
        } else {
          newSums.previous = sums.previous;
        }

        if (index < nextPane) {
          newSums.next = sums.next + val + margin;
        } else if (index === nextPane) {
          newSums.next = sums.next + val / 2;
        } else {
          newSums.next = sums.next;
        }
        return newSums;
      }, { previous: 0, next: 0 });
    };

    _this.updateOrder = function (panes, index, mode) {
      return panes.map(function (pane) {
        if (pane.order >= index) {
          var _id = pane.id,
              _width = pane.width,
              _height = pane.height,
              _order = pane.order;

          return { id: _id, width: _width, height: _height, order: mode === 'add' ? _order + 1 : _order - 1 };
        }
        return pane;
      });
    };

    _this.state = {
      delta: 0,
      mouse: 0,
      isPressed: false,
      lastPressed: 0,
      isResizing: false,
      panes: (_this.props.children || []).map(function (child, order) {
        return {
          id: child.props.id,
          width: child.props.width,
          height: child.props.height,
          order: order
        };
      })
    };
    _this.sizePropsUpdated = false;
    _this.handleTouchMove = _this.handleTouchMove.bind(_this);
    _this.handleMouseUp = _this.handleMouseUp.bind(_this);
    _this.handleMouseMove = _this.handleMouseMove.bind(_this);

    if (typeof window !== 'undefined') {
      window.addEventListener('touchmove', _this.handleTouchMove);
      window.addEventListener('touchend', _this.handleMouseUp);
      window.addEventListener('mousemove', _this.handleMouseMove);
      window.addEventListener('mouseup', _this.handleMouseUp);
    }
    return _this;
  }

  _createClass(SortablePane, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setSize();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(next) {
      var newPanes = [];
      var order = this.getPanePropsArrayOf('order');
      if (!isEqual(this.props.order, next.order)) {
        for (var i = 0; i < next.order.length; i += 1) {
          if (this.state.panes.length) {
            var _pane = this.state.panes[parseInt(order[i], 10)];
            newPanes[next.order[i]] = _pane;
          }
        }
        this.setState({ panes: newPanes });
      }

      if (!next.children || next.children.length === 0) return;
      var children = this.props.children || [];
      for (var _i = 0; _i < children.length; _i += 1) {
        if (next.children[_i]) {
          var child = children[_i];
          if (child) {
            var _width2 = child.props.width;
            var _height2 = child.props.height;
            var newWidth = next.children[_i].props.width;
            var newHeight = next.children[_i].props.height;
            if (_width2 !== newWidth || _height2 !== newHeight) this.sizePropsUpdated = true;
          }
        }
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var panes = this.state.panes;

      var children = this.props.children || [];
      if (children.length > panes.length) return this.addPane();
      if (children.length < panes.length) return this.removePane();
      if (this.sizePropsUpdated) {
        this.sizePropsUpdated = false;
        this.setSize();
      }
      return undefined;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (typeof window !== 'undefined') {
        window.removeEventListener('touchmove', this.handleTouchMove);
        window.removeEventListener('touchend', this.handleMouseUp);
        window.removeEventListener('mousemove', this.handleMouseMove);
        window.removeEventListener('mouseup', this.handleMouseUp);
      }
    }
  }, {
    key: 'onResize',
    value: function onResize(i, e, dir, refToElement, delta) {
      var _this2 = this;

      var panes = this.state.panes;

      var order = this.getPanePropsArrayOf('order');
      panes = panes.map(function (pane, index) {
        if (order.indexOf(i) === index && _this2.panes) {
          var _panes$children$i = _this2.panes.children[i],
              offsetWidth = _panes$children$i.offsetWidth,
              offsetHeight = _panes$children$i.offsetHeight;

          return {
            width: offsetWidth,
            height: offsetHeight,
            order: pane.order,
            id: pane.id
          };
        }
        return pane;
      });
      this.setState({ panes: panes });
      var pane = panes[order.indexOf(i)];
      if (!pane) return;
      if (!this.props.onResize) return;
      this.props.onResize(e, pane.id, panes, {
        pane: pane,
        direction: directionDict[dir],
        delta: delta
      });
    }
  }, {
    key: 'getPanePropsArrayOf',
    value: function getPanePropsArrayOf(key) {
      return this.state.panes.map(function (pane) {
        return pane['' + key];
      });
    }
  }, {
    key: 'getPaneSizeList',
    value: function getPaneSizeList() {
      var width = this.getPanePropsArrayOf('width');
      var height = this.getPanePropsArrayOf('height');
      return this.isHorizontal() ? width : height;
    }

    /**
     * Find the position sum of halfway points of panes surrounding a given pane
     *
     *  |-------------|
     *  |             | ---> 'previous' halfway
     *  |-------------|
     *                  <--- margin
     *  |-------------|
     *  | currentPane |
     *  |-------------|
     *                  <--- margin
     *  |-------------|
     *  |             |
     *  |             | ---> 'next' halfway
     *  |             |
     *  |-------------|
     *
     *
     * @param  {number}   currentPane - Index of rerference pane
     * @param  {number[]} sizes       - Array of pane sizes
     * @param  {number}   margin      - The margin between panes
     * @return {object}               - Object containing 'prevoius' and 'next'
     *                                  pane halfway points
     */

  }, {
    key: 'getItemCountByPosition',


    /**
     * Determine where a particular pane should be ordered
     *
     * @param  {number} position     - Top of the current pane
     * @param  {number} paneIndex    - Index of the pane
     * @return {number}              - New index of the pane based on position
     */
    value: function getItemCountByPosition(position, paneIndex) {
      var size = this.getPaneSizeList();
      var margin = this.props.margin;

      var halfsizes = this.getSurroundingHalfSizes(paneIndex, size, margin || 0);

      if (position + size[paneIndex] > halfsizes.next) return paneIndex + 1;
      if (position < halfsizes.previous) return paneIndex - 1;
      return paneIndex;
    }
  }, {
    key: 'setSize',
    value: function setSize() {
      if (!this.panes || !this.panes.children) return;
      var panes = this.panes;
      var children = this.props.children || [];
      var newPanes = children.map(function (child, i) {
        var _panes$children$i2 = panes.children[i],
            offsetWidth = _panes$children$i2.offsetWidth,
            offsetHeight = _panes$children$i2.offsetHeight;

        return {
          id: child.props.id,
          width: offsetWidth,
          height: offsetHeight,
          order: i
        };
      });
      if (!isEqual(newPanes, this.state.panes)) this.setState({ panes: newPanes });
    }
  }, {
    key: 'getItemPositionByIndex',
    value: function getItemPositionByIndex(index) {
      var size = this.getPaneSizeList();
      var sum = 0;
      for (var i = 0; i < index; i += 1) {
        sum += size[i] + this.props.margin;
      }
      return sum;
    }
  }, {
    key: 'isHorizontal',
    value: function isHorizontal() {
      return this.props.direction === 'horizontal';
    }
  }, {
    key: 'addPane',
    value: function addPane() {
      var _this3 = this;

      if (!this.panes || !this.panes.children) return;
      var panes = this.panes;
      var newPanes = this.state.panes;
      var children = this.props.children || [];
      children.forEach(function (child, i) {
        var ids = _this3.state.panes.map(function (pane) {
          return pane.id;
        });
        if (ids.indexOf(child.props.id) === -1) {
          newPanes = _this3.updateOrder(newPanes, i, 'add');
          var _id2 = child.props.id;

          var _panes$children$i$get = panes.children[i].getBoundingClientRect(),
              _width3 = _panes$children$i$get.width,
              _height3 = _panes$children$i$get.height;

          var _pane2 = { id: _id2, width: _width3, height: _height3, order: i };
          newPanes.splice(i, 0, _pane2);
        }
      });
      this.setState({ panes: newPanes });
    }
  }, {
    key: 'removePane',
    value: function removePane() {
      var _this4 = this;

      var newPanes = void 0;
      var children = this.props.children || [];
      this.state.panes.forEach(function (pane, i) {
        var ids = children.map(function (child) {
          return child.props.id;
        });
        if (ids.indexOf(pane.id) === -1) {
          newPanes = _this4.updateOrder(_this4.state.panes, pane.order, 'remove');
          newPanes.splice(i, 1);
        }
      });
      this.setState({ panes: newPanes });
    }
  }, {
    key: 'handleResizeStart',
    value: function handleResizeStart(i, e) {
      var panes = this.state.panes;

      var order = this.getPanePropsArrayOf('order');
      this.setState({ isResizing: true });
      var id = panes[order.indexOf(i)].id;
      if (typeof id === 'undefined') return;
      if (this.props.onResizeStart) {
        this.props.onResizeStart(e, id, panes);
      }
    }
  }, {
    key: 'handleResizeStop',
    value: function handleResizeStop(i, e, dir, refToElement, delta) {
      var panes = this.state.panes;

      var order = this.getPanePropsArrayOf('order');
      this.setState({ isResizing: false });
      var pane = panes[order.indexOf(i)];
      var id = pane.id;
      if (typeof id === 'undefined') return;
      if (this.props.onResizeStop) {
        this.props.onResizeStop(e, id, panes, {
          pane: pane,
          direction: directionDict[dir],
          delta: delta
        });
      }
    }
  }, {
    key: 'handleMouseDown',
    value: function handleMouseDown(pos, pressX, pressY, e) {
      if (this.props.dragHandleClassName) {
        if (e.target instanceof HTMLElement) {
          if (!e.target.classList.contains(this.props.dragHandleClassName)) {
            return;
          }
        }
      }
      var delta = void 0;
      if (e.nativeEvent instanceof TouchEvent) {
        var event = e.nativeEvent.touches[0];
        delta = this.isHorizontal() ? event.pageX - pressX : event.pageY - pressY;
      } else if (e.nativeEvent instanceof MouseEvent) {
        var _event = e.nativeEvent;
        delta = this.isHorizontal() ? _event.pageX - pressX : _event.pageY - pressY;
      }
      this.setState({
        delta: delta,
        mouse: this.isHorizontal() ? pressX : pressY,
        isPressed: true,
        lastPressed: pos
      });
      if (!this.props.children) return;
      var child = this.props.children[pos];
      if (!child) return;
      if (this.props.onDragStart) {
        this.props.onDragStart(e, child.props.id, this.state.panes);
      }
    }
  }, {
    key: 'handleMouseMove',
    value: function handleMouseMove(_ref) {
      var pageX = _ref.pageX,
          pageY = _ref.pageY;
      var _state = this.state,
          isPressed = _state.isPressed,
          delta = _state.delta,
          lastPressed = _state.lastPressed,
          isResizing = _state.isResizing,
          panes = _state.panes;

      if (isPressed && !isResizing) {
        var _mouse = this.isHorizontal() ? pageX - delta : pageY - delta;

        var _ref2 = this.props.children || [],
            length = _ref2.length;

        var _order2 = this.getPanePropsArrayOf('order');
        var newPosition = this.getItemCountByPosition(_mouse, _order2.indexOf(lastPressed));
        var row = clamp(Math.round(newPosition), 0, length - 1);
        var _newPanes = reinsert(panes, _order2.indexOf(lastPressed), row);
        this.setState({ mouse: _mouse, panes: _newPanes });
        if (!this.props.onOrderChange) return;
        if (!isEqual(panes, _newPanes)) {
          if (this.props.onOrderChange) {
            this.props.onOrderChange(panes, _newPanes);
          }
        }
      }
    }
  }, {
    key: 'handleTouchStart',
    value: function handleTouchStart(key, x, y, e) {
      this.handleMouseDown(key, x, y, e);
    }
  }, {
    key: 'handleTouchMove',
    value: function handleTouchMove(e) {
      e.preventDefault();
      this.handleMouseMove(e.touches[0]);
    }
  }, {
    key: 'handleMouseUp',
    value: function handleMouseUp(e) {
      var children = this.props.children || [];
      if (children.length === 0) return;
      this.setState({ isPressed: false, delta: 0 });
      var child = children[this.state.lastPressed];
      var lastPressedId = child.props.id;
      // const pane = this.state.panes.find(p => p.id === lastPressedId);
      if (!this.props.isSortable) return;
      if (this.props.onDragStop) {
        this.props.onDragStop(e, lastPressedId, this.state.panes);
      }
    }
  }, {
    key: 'renderPanes',
    value: function renderPanes() {
      var _this5 = this;

      var _state2 = this.state,
          mouse = _state2.mouse,
          isPressed = _state2.isPressed,
          lastPressed = _state2.lastPressed,
          isResizing = _state2.isResizing;

      var order = this.getPanePropsArrayOf('order');
      var _props = this.props,
          disableEffect = _props.disableEffect,
          isSortable = _props.isSortable,
          zIndex = _props.zIndex;

      var children = this.props.children || [];
      return children.map(function (child, i) {
        var springPosition = spring(_this5.getItemPositionByIndex(order.indexOf(i)), springConfig);
        var style = lastPressed === i && isPressed ? {
          scale: disableEffect ? 1 : spring(1.05, springConfig),
          shadow: disableEffect ? 0 : spring(16, springConfig),
          x: _this5.isHorizontal() ? mouse : 0,
          y: !_this5.isHorizontal() ? mouse : 0
        } : {
          scale: disableEffect ? 1 : spring(1, springConfig),
          shadow: disableEffect ? 0 : spring(0, springConfig),
          x: _this5.isHorizontal() ? springPosition : 0,
          y: !_this5.isHorizontal() ? springPosition : 0
        };
        return createElement(
          Motion,
          { style: style, key: child.props.id },
          function (_ref3) {
            var scale = _ref3.scale,
                shadow = _ref3.shadow,
                x = _ref3.x,
                y = _ref3.y;

            var onResize = _this5.onResize.bind(_this5, i);
            var onMouseDown = isSortable ? _this5.handleMouseDown.bind(_this5, i, x, y) : function () {
              return null;
            };
            var onTouchStart = _this5.handleTouchStart.bind(_this5, i, x, y);
            var onResizeStart = _this5.handleResizeStart.bind(_this5, i);
            var onResizeStop = _this5.handleResizeStop.bind(_this5, i);
            var userSelect = isPressed || isResizing ? {
              userSelect: 'none',
              MozUserSelect: 'none',
              WebkitUserSelect: 'none',
              MsUserSelect: 'none'
            } : {
              userSelect: 'auto',
              MozUserSelect: 'auto',
              WebkitUserSelect: 'auto',
              MsUserSelect: 'auto'
            };

            // take a copy rather than direct-manipulating the child's prop, which violates React
            // and causes problems if the child's prop is a static default {}, which then will be
            // shared across all children!
            var customStyle = Object.assign({}, child.props.style);
            Object.assign(customStyle, {
              boxShadow: 'rgba(0, 0, 0, 0.2) 0px ' + shadow + 'px ' + 2 * shadow + 'px 0px',
              transform: 'translate3d(' + x + 'px, ' + y + 'px, 0px) scale(' + scale + ')',
              WebkitTransform: 'translate3d(' + x + 'px, ' + y + 'px, 0px) scale(' + scale + ')',
              MozTransform: 'translate3d(' + x + 'px, ' + y + 'px, 0px) scale(' + scale + ')',
              MsTransform: 'translate3d(' + x + 'px, ' + y + 'px, 0px) scale(' + scale + ')',
              zIndex: i === lastPressed ? zIndex + children.length : zIndex + i,
              position: 'absolute'
            }, userSelect);

            var extendsProps = {
              onMouseDown: onMouseDown,
              onTouchStart: onTouchStart
            };

            return createElement(
              Resizable,
              {
                className: child.props.className,
                onResize: onResize,
                enable: {
                  top: false,
                  right: child.props.isResizable.x,
                  bottomRight: child.props.isResizable.xy,
                  bottom: child.props.isResizable.y,
                  left: false,
                  topRight: false,
                  bottomLeft: false,
                  topLeft: false
                },
                width: child.props.width,
                height: child.props.height,
                minWidth: child.props.minWidth,
                minHeight: child.props.minHeight,
                maxWidth: child.props.maxWidth,
                maxHeight: child.props.maxHeight,
                style: customStyle,
                onResizeStart: onResizeStart,
                onResizeStop: onResizeStop,
                extendsProps: extendsProps,
                grid: _this5.props.grid
              },
              child.props.children
            );
          }
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      var _props2 = this.props,
          style = _props2.style,
          className = _props2.className;

      return createElement(
        'div',
        {
          ref: function ref(c) {
            _this6.panes = c;
          },
          className: className,
          style: _extends({ position: 'relative', height: '100%' }, style)
        },
        this.renderPanes()
      );
    }
  }]);

  return SortablePane;
}(Component);

SortablePane.defaultProps = {
  order: [],
  direction: 'horizontal',
  style: {},
  children: [],
  margin: 0,
  onClick: function onClick() {
    return null;
  },
  onTouchStart: function onTouchStart() {
    return null;
  },
  onResizeStart: function onResizeStart() {
    return null;
  },
  onResize: function onResize() {
    return null;
  },
  onResizeStop: function onResizeStop() {
    return null;
  },
  onDragStart: function onDragStart() {
    return null;
  },
  onDragStop: function onDragStop() {
    return null;
  },
  onOrderChange: function onOrderChange() {
    return null;
  },
  className: '',
  disableEffect: false,
  isSortable: true,
  zIndex: 100
};

export { Pane, SortablePane };
//# sourceMappingURL=react-sortable-pane.js.map
